/*
 * A Decibel TextChannel GUI
 * Copyright (C) 2008 George Goldberg <grundleborg@googlemail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
 
#ifndef TCC_CHATWINDOW_H
#define TCC_CHATWINDOW_H

#include "ui_chatwindow.h"

#include <QtGui/QStandardItemModel>

#include <QtTapioca/TextChannel>

class ChatWindow : public QWidget, private Ui::ChatWindow {

    Q_OBJECT

    public:
        ChatWindow(QtTapioca::Connection * connection,
                   QtTapioca::TextChannel * channel,
                   QWidget * parent = 0);
        ~ChatWindow();

    public Q_SLOTS:
        void onMessageReceived();
        void onCloseChannel();
        void sendMessage();

    private:
        QStandardItemModel *m_messagesModel;
        QtTapioca::TextChannel *m_channel;
        QtTapioca::Connection *m_connection;
};

#endif // header guard

