/* Copyright 2008 Tobias Hunger <tobias.hunger@basyskom.de>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* This code is generated from the telepathy specification.
 * DO NOT EDIT!
 */

#include <QtTelepathy/Common/generic_types>
#include <QtTelepathy/Common/Channel_Type_Tubes_Types>


const QDBusArgument & operator >> (const QDBusArgument & arg,
                                   org::freedesktop::Telepathy::TubeInfo & param)
{
    arg.beginStructure();
    arg >> param.identifier;
    arg >> param.initiator;
    arg >> param.type;
    arg >> param.service;
    arg >> param.parameters;
    arg >> param.state;
    arg.endStructure();
    return arg;
}
QDBusArgument & operator << (QDBusArgument & arg,
                             const org::freedesktop::Telepathy::TubeInfo & param)
{
    arg.beginStructure();
    arg << param.identifier;
    arg << param.initiator;
    arg << param.type;
    arg << param.service;
    arg << param.parameters;
    arg << param.state;
    arg.endStructure();
    return arg;
}

const QDBusArgument & operator >> (const QDBusArgument & arg,
                                   org::freedesktop::Telepathy::DBusTubeMember & param)
{
    arg.beginStructure();
    arg >> param.handle;
    arg >> param.uniqueName;
    arg.endStructure();
    return arg;
}
QDBusArgument & operator << (QDBusArgument & arg,
                             const org::freedesktop::Telepathy::DBusTubeMember & param)
{
    arg.beginStructure();
    arg << param.handle;
    arg << param.uniqueName;
    arg.endStructure();
    return arg;
}

const QDBusArgument & operator >> (const QDBusArgument & arg,
                                   org::freedesktop::Telepathy::SocketAddressIPv4 & param)
{
    arg.beginStructure();
    arg >> param.address;
    arg >> param.port;
    arg.endStructure();
    return arg;
}
QDBusArgument & operator << (QDBusArgument & arg,
                             const org::freedesktop::Telepathy::SocketAddressIPv4 & param)
{
    arg.beginStructure();
    arg << param.address;
    arg << param.port;
    arg.endStructure();
    return arg;
}

const QDBusArgument & operator >> (const QDBusArgument & arg,
                                   org::freedesktop::Telepathy::SocketAddressIPv6 & param)
{
    arg.beginStructure();
    arg >> param.address;
    arg >> param.port;
    arg.endStructure();
    return arg;
}
QDBusArgument & operator << (QDBusArgument & arg,
                             const org::freedesktop::Telepathy::SocketAddressIPv6 & param)
{
    arg.beginStructure();
    arg << param.address;
    arg << param.port;
    arg.endStructure();
    return arg;
}

const QDBusArgument & operator >> (const QDBusArgument & arg,
                                   org::freedesktop::Telepathy::SocketNetmaskIPv4 & param)
{
    arg.beginStructure();
    arg >> param.address;
    arg >> param.prefixLength;
    arg.endStructure();
    return arg;
}
QDBusArgument & operator << (QDBusArgument & arg,
                             const org::freedesktop::Telepathy::SocketNetmaskIPv4 & param)
{
    arg.beginStructure();
    arg << param.address;
    arg << param.prefixLength;
    arg.endStructure();
    return arg;
}

const QDBusArgument & operator >> (const QDBusArgument & arg,
                                   org::freedesktop::Telepathy::SocketNetmaskIPv6 & param)
{
    arg.beginStructure();
    arg >> param.address;
    arg >> param.prefixLength;
    arg.endStructure();
    return arg;
}
QDBusArgument & operator << (QDBusArgument & arg,
                             const org::freedesktop::Telepathy::SocketNetmaskIPv6 & param)
{
    arg.beginStructure();
    arg << param.address;
    arg << param.prefixLength;
    arg.endStructure();
    return arg;
}

const QDBusArgument & operator >> (const QDBusArgument & arg,
                                   org::freedesktop::Telepathy::TubeType & param)
{
    quint32 tmp;
    arg >> tmp;
    param = static_cast< org::freedesktop::Telepathy::TubeType >(tmp);
    return arg;
}
QDBusArgument & operator << (QDBusArgument & arg,
                                   const org::freedesktop::Telepathy::TubeType & param)
{
    arg << static_cast< quint32 >(param);
    return arg;
}

const QDBusArgument & operator >> (const QDBusArgument & arg,
                                   org::freedesktop::Telepathy::TubeState & param)
{
    quint32 tmp;
    arg >> tmp;
    param = static_cast< org::freedesktop::Telepathy::TubeState >(tmp);
    return arg;
}
QDBusArgument & operator << (QDBusArgument & arg,
                                   const org::freedesktop::Telepathy::TubeState & param)
{
    arg << static_cast< quint32 >(param);
    return arg;
}

const QDBusArgument & operator >> (const QDBusArgument & arg,
                                   org::freedesktop::Telepathy::SocketAddressType & param)
{
    quint32 tmp;
    arg >> tmp;
    param = static_cast< org::freedesktop::Telepathy::SocketAddressType >(tmp);
    return arg;
}
QDBusArgument & operator << (QDBusArgument & arg,
                                   const org::freedesktop::Telepathy::SocketAddressType & param)
{
    arg << static_cast< quint32 >(param);
    return arg;
}

const QDBusArgument & operator >> (const QDBusArgument & arg,
                                   org::freedesktop::Telepathy::SocketAccessControl & param)
{
    quint32 tmp;
    arg >> tmp;
    param = static_cast< org::freedesktop::Telepathy::SocketAccessControl >(tmp);
    return arg;
}
QDBusArgument & operator << (QDBusArgument & arg,
                                   const org::freedesktop::Telepathy::SocketAccessControl & param)
{
    arg << static_cast< quint32 >(param);
    return arg;
}

